
#include <oslib/oslib.h>
#include "include/oslanimlib/oslanimlib.cpp"

extern "C"
{
#include "Include/mad.h"
#include "Include/MusicEngine.h"
#include "Include/main.h"
}

PSP_MODULE_INFO("PSP Pileup",0,1,1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);
PSP_HEAP_SIZE_KB(20480);


#define printf pspDebugScreenPrintf
#define MAX(X, Y) ((X) > (Y) ? (X) : (Y))

OSL_IMAGE *Pic1, *explosion, *space, *ball, *ourImage, *ourImage2, *ourImage3, *ourImage4, *ourImage5, *ourImage6, *ourImage7, *ourImage8, *num2, *num3, *num4, *num5, *num6, *num7, *num8, *num9, *inf;
OSL_FONT *font, *shooterfont;
OSL_ANIMATION animExplosion;
OSL_SOUND *cheese;

int a = 10;	// how many times the screen should refresh before going to the next step.
int b = 17;	// how wide the pic1 is so y can be incremented, can be changed to one for a smooth movement if desired.
int c = 20;	// how many pic1's that can fit in the screen lengthways.
int d = 1;	// alternate to h
int f = 0;	// to make sure that x doesnt get pressed more than once a cycle.
int g = 10;	// refresh for a, a gets reset to this once a is 0
int h = 1;	// brick number display
int j = 0;	// old stack diff
int k = 1;	// level num.
int l = 0;	// used for testing if X is pressed, another safety procedure.
float m = 0;	// drawcircle alpha level
int x = 456;	// x at the beginning, 24 pixels off the bottom
int y = 0;	// y at the beginning.
int ad = 3; 	// used for how much bricks should be put on the screen, try a different integer for the bricks
int ay = 3;	// delay for menu
int az = 21;	// when to minus one brick
int ba = 21;	// same as az, but the next level.
int bc = 0;	// youwin time
int bd = 0;	// youlose flipscreen
int be = 10;	// almost permanent g num
int bf = 0;	// score
int bg = 10;	// fibbonacci sequence speed multiplier
int bh = 10;	// minus speed score
int bi = 0;	// x press recycle
int bv = 0;	// readScore(); repeat
int by = 0;	// mp3 number
int cb = 0;	// 1000 unlock
int explosionX = -160;
int explosionY = -125;
int back = 0;	// menu break
int n = 20;	// here to show when you have won, after level 1 it craps up without this
float line1 = 0;
float line2 = 272;	// fade in screen lines

/////////////////////////////////////////////////////////////////////////////////////////////////////////////// alternate play mode

int cc = 0;	// alternate play mode enable
int cd = 240;	// cannon 1 x
int ce = 240;	// cannon 2 x
int cf = 0;	// cannon 1 speed
int cg = 0;	// cannon 2 speed
int ch = 0;	// random number 1
int ci = 0;	// random number 2
int cj = 0;	// bricks bounce 1
int ck = 0;	// bricks bounce 2
int randnum1 = 0;	// random number for cannon shoot
int randnum2 = 0;	// "
int drop = 0;	// when to drop a brick line
int fadein = 255;// fadein var
int timeMil = 1;	// time miliseconds spaceshooter
int timemult = 2;	// time multiplier "
//bool bossalpha = false;	// boss fadeinout indicator
//bool bossenable = false;// boss fight enable




// PONG!!!
int bj = 225;	// ball x
int bk = 121;	// ball y
int bl = 111;	// player 1 y
int bm = 111;	// player 2 y
int bn = 0;	// minigame unlock status
int bo = 50;	// bat size
int bp = 5;	// player1 x
int bq = 475;	// player2 x
int br = 2;	// ball movement x
int bs = 0;	// ball movement y
int bt = 0;	// player1 score
int bu = 0;	// player2 score
int bw = 2;	// ai speed

int bz = 0; // 1000 minigame number
int ca = 0; // minigame number press
char num[4];

// shooter minigame!

int shipX = 240;
int shipY = 136;
int end = 0;		// end of minigame indicator
float speedX = 0;	// ship speed x
float speedY = 0; 	// ship speed y
int backspeed = 3;	// background speed
int cl = 0;		// background X co-ordinate
int cm = 0;		// enemy number
int life = 3;		// amount of lives you have
int sheild = 480;	// sheild amount
int recover = 1;	// recover sheild speed
int sheild_color = 150;	// sheild line color indicator

int bulletX1 = 0;
int bulletY1 = 0;
bool bullet1enable = false;

brick block[MAX_BLOCKS];


enemy object[MAX_ENEMIES];

time_t seconds;


char timesec[10];
char score[10];
char music[7];
char musicbuffer[2048];
char filler[20];
char temp[50];
int selComponent = 0;
int difficulty = 0;
FILE *pfile;
int high_score[50];

enum colors
{
    RED =	0xFF0000FF,
    GREEN =	0xFF00FF00,
    BLUE =	0xFFFF0000,
    WHITE =	0xFFFFFFFF
};

OSL_COLOR Player1 = RGB(0,0,255);
OSL_COLOR Player2 = RGB(255,0,0);
OSL_COLOR highlightColor = RGB(200, 200, 200);
OSL_COLOR dimmedColor = RGB(100, 100, 100);
OSL_COLOR BLACK = RGB(0, 0, 0 );

void checkXbutton();
void writeScore();
void readScore();
void nextMp3();
void loadBuffer();
void spaceShooter();
void PONG();
void one000();
void blockSet();
void blockDisplay();
void blockCheck();
void resetVar();
void drawImageAlpha(int X, int Y, int alpha, OSL_IMAGE *image);
void pileUp();


int myExitCallback(int arg1, int arg2, void *common)
{
    oslQuit();
    return 0;
}

int main()
{
    scePowerSetClockFrequency(333, 333, 166);
    pspDebugScreenInit();
    Init(1);
    oslInit(0);
    oslSetExitCallback(myExitCallback);
    oslInitGfx(OSL_PF_8888, 1);
    oslInitConsole();
    oslInitAudio();
    oslSetBkColor(RGBA(0,0,0,0));

    sprintf(temp,"bricks/fonts/menufont.oft");
    font = oslLoadFontFile(temp);

    sprintf(temp,"bricks/fonts/shooterfont.oft");
    shooterfont = oslLoadFontFile(temp);

    oslSetFont(font);

    animExplosion.Load("Bricks/Explosion/Angular Explosion",14);

    animExplosion.Initialize(0,0,48,34,0, 13,2,false, false, false);

    explosion = oslLoadImageFile("bricks/explosion.png", OSL_IN_RAM, OSL_PF_8888);
    space = oslLoadImageFile("bricks/space.png", OSL_IN_RAM, OSL_PF_8888);
    ball = oslLoadImageFile("bricks/ball.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage = oslLoadImageFile("bricks/Pic1.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage2 = oslLoadImageFile("bricks/background.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage3 = oslLoadImageFile("bricks/youlose.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage4 = oslLoadImageFile("bricks/youwin.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage5 = oslLoadImageFile("bricks/level.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage6 = oslLoadImageFile("bricks/1.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage7 = oslLoadImageFile("bricks/idol.png", OSL_IN_RAM, OSL_PF_8888);
    ourImage8 = oslLoadImageFile("bricks/backgroundmenu.png", OSL_IN_RAM, OSL_PF_8888);
    num2 = oslLoadImageFile("bricks/2.png", OSL_IN_RAM, OSL_PF_8888);
    num3 = oslLoadImageFile("bricks/3.png", OSL_IN_RAM, OSL_PF_8888);
    num4 = oslLoadImageFile("bricks/4.png", OSL_IN_RAM, OSL_PF_8888);
    num5 = oslLoadImageFile("bricks/5.png", OSL_IN_RAM, OSL_PF_8888);
    num6 = oslLoadImageFile("bricks/6.png", OSL_IN_RAM, OSL_PF_8888);
    num7 = oslLoadImageFile("bricks/7.png", OSL_IN_RAM, OSL_PF_8888);
    num8 = oslLoadImageFile("bricks/8.png", OSL_IN_RAM, OSL_PF_8888);
    num9 = oslLoadImageFile("bricks/9.png", OSL_IN_RAM, OSL_PF_8888);
    inf = oslLoadImageFile("bricks/inf.png", OSL_IN_RAM, OSL_PF_8888);
    Pic1 = oslLoadImageFile("bricks/Pic1.png", OSL_IN_RAM, OSL_PF_8888);

    //cheese = oslLoadSoundFile("bricks/bullet.wav", OSL_FMT_NONE);

    Stop();

    Load("menu.mp3");
    fillOutputBuffer(musicbuffer, 1, 0);
    Play();
    //resetVar();


    while (!osl_quit)
    {

        if (back == 1)
        {
            back = 0;
        }


        oslReadKeys();

        while (bv == 0)
        {
            bv = 1;
            readScore();
        }
        bf = high_score[0];

        if (EndOfStream() == 1)
        {
            Stop();
            Load("menu.mp3");
            fillOutputBuffer(musicbuffer, 1, 0);
            Play();
        }
        loadBuffer();


        if (osl_keys->pressed.up)
        {
            if (selComponent > 0)
            {
                //oslPlaySound(cheese, 0);
                selComponent--;
            }
            sceKernelDelayThread(10);
        }
        else if (osl_keys->pressed.down)
        {
            if (selComponent < 4)
            {
                //oslPlaySound(cheese, 0);
                selComponent++;
            }
            sceKernelDelayThread(10);
        }

        if (osl_keys->pressed.cross)
        {
            switch (selComponent)
            {
            case 0:

                fadeOut();

                fadein = 255;

                sceKernelDelayThread(10);
                while (!osl_quit && back == 0)
                {
                    if (EndOfStream() == 1)
                    {
                        Stop();
                        Load("menu.mp3");
                        fillOutputBuffer(musicbuffer, 1, 0);
                        Play();
                    }



                    oslReadKeys();

                    if (osl_keys->pressed.up)
                    {
                        if (difficulty > 0)
                        {
                            difficulty--;
                        }
                        sceKernelDelayThread(10);
                    }
                    else if (osl_keys->pressed.down)
                    {
                        if (difficulty < 2)
                        {
                            difficulty++;
                        }
                        sceKernelDelayThread(10);

                    }
                    loadBuffer();

                    if (osl_keys->held.cross)
                    {
                        switch (difficulty)
                        {
                        case 0:
                            cc = 0;
                            fadeOut();
                            fadein = 50;
                            pileUp();
                            resetVar();
                            break;
                        case 1:
                            cc = 1;
                            fadeOut();
                            fadein = 255;
                            pileUp();
                            fadein = 255;
                            resetVar();
                            break;

                        case 2:
                            fadeOut();
                            fadein = 255;
                            back = 1;
                            break;


                        default:
                            break;
                        }
                    }



                    oslStartDrawing();
                    oslCls();


                    oslDrawImageXY ( ourImage8,0, 0);
                    sprintf(filler, " Classic");
                    if (difficulty == 0)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 110, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 110, filler, dimmedColor);
                    }
                    sprintf(filler, " New age!");
                    if (difficulty == 1)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 125, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 125, filler, dimmedColor);
                    }

                    sprintf(filler, " Back");
                    if (difficulty == 2)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 140, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 140, filler, dimmedColor);
                    }

                    if (fadein > 0)
                    {
                        fadein -= 5;
                        fadeIn(fadein, line1, line2);
                        line1 += 2.72;
                        line2 -= 2.72;
                    }
                    else
                    {
                        line1 = 0;
                        line2 = 272;
                    }
                    fullscreenStatic(25);

                    oslEndDrawing();

                    oslSyncFrame();

                }
                break;

            case 1:

                fadeOut();

                sceKernelDelayThread(10);

                fadein = 255;

                while (!osl_quit && back == 0)
                {
                    if (EndOfStream() == 1)
                    {
                        Stop();
                        Load("menu.mp3");
                        fillOutputBuffer(musicbuffer, 1, 0);
                        Play();
                    }






                    oslReadKeys();

                    if (osl_keys->pressed.up)
                    {
                        if (difficulty > 0)
                        {
                            difficulty--;
                        }
                        sceKernelDelayThread(10);
                    }
                    else if (osl_keys->pressed.down)
                    {
                        if (difficulty < 4)
                        {
                            difficulty++;
                        }
                        sceKernelDelayThread(10);

                    }
                    loadBuffer();

                    if (osl_keys->pressed.cross)
                    {
                        switch (difficulty)
                        {
                        case 0:
                            a = 13;
                            g = 13;
                            be = 13;
                            oslStartDrawing();
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(150, 50, "Difficulty set to easy.");
                            oslEndDrawing();
                            oslSyncFrame();
                            sceKernelDelayThread(10);
                            break;
                        case 1:
                            a = 7;
                            g = 7;
                            be = 7;
                            oslStartDrawing();
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(150, 50, "Difficulty set to medium.");
                            oslEndDrawing();
                            oslSyncFrame();
                            sceKernelDelayThread(10);
                            break;
                        case 2:
                            a = 5;
                            g = 5;
                            be = 5;
                            oslStartDrawing();
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(150, 50, "Difficulty set to hard.");
                            oslEndDrawing();
                            oslSyncFrame();
                            sceKernelDelayThread(10);
                            break;
                        case 3:
                            a = 1;
                            g = 1;
                            be = 1;
                            oslStartDrawing();
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(150, 50, "Difficulty set to ULTRA HARD!!!!!");
                            oslEndDrawing();
                            oslSyncFrame();
                            sceKernelDelayThread(10);

                        case 4:

                            sceKernelDelayThread(10);
                            difficulty = 0;
                            back = 1;
                            fadein = 255;
                            fadeOut();
                            break;

                        default:
                            //SHOULD NEVER EXECUTE
                            break;
                        }
                    }



                    oslStartDrawing();
                    oslCls();
                    oslDrawImageXY ( ourImage8,0, 0);


                    sprintf(filler, " Easy");
                    if (difficulty == 0)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 110, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 110, filler, dimmedColor);
                    }

                    sprintf(filler, " Medium");
                    if (difficulty == 1)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 125, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 125, filler, dimmedColor);
                    }

                    sprintf(filler, " Hard");
                    if (difficulty == 2)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 140, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 140, filler, dimmedColor);
                    }

                    sprintf(filler, " ULTRA HARD!");
                    if (difficulty == 3)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 155, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 155, filler, dimmedColor);
                    }

                    sprintf(filler, " Back");
                    if (difficulty == 4)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 170, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 170, filler, dimmedColor);
                    }
                    if (fadein > 0)
                    {
                        fadein -= 5;
                        fadeIn(fadein, line1, line2);
                        line1 += 2.72;
                        line2 -= 2.72;
                    }
                    else
                    {
                        line1 = 0;
                        line2 = 272;
                    }

                    fullscreenStatic(25);

                    oslEndDrawing();



                    oslSyncFrame();







                }
                break;


            case 2:

                fadeOut();

                fadein = 255;

                oslCls();

                while (!osl_quit && back == 0)
                {



                    if (EndOfStream() == 1)
                    {
                        Stop();
                        Load("menu.mp3");
                        fillOutputBuffer(musicbuffer, 1, 0);
                        Play();
                    }
                    oslStartDrawing();
                    loadBuffer();
                    oslCls();
                    oslDrawImageXY ( ourImage8,0, 0);
                    oslReadKeys();
                    oslSetTextColor(highlightColor);

                    oslPrintf_xy(0, 0, "PSP pileup, developed by Jack hosemans A.K.A Sangheili");
                    oslPrintf_xy(0, 20, "This game is played vertically, power switch towards you.");
                    oslPrintf_xy(0, 30, "X is to stop the current group of blocks and the left");
                    oslPrintf_xy(0, 40, "trigger is to pause the game and go back to the main menu");
                    oslPrintf_xy(0, 50, "If you misalign the blocks too many time you lose!");
                    oslPrintf_xy(0, 60, "There are technically ten levels, but are really infinite.");
                    oslPrintf_xy(0, 70, "There are three levels of difficulty, harder is faster. ");
                    oslPrintf_xy(0, 90, "Known bugs:");
                    oslPrintf_xy(0, 100, "blocks will always align on the right");

                    oslPrintf_xy(0, 120, "if any other bugs are found, email jh247247@hotmail.com ");
                    oslPrintf_xy(0, 140, "PSP pileup is totally opensource, just leave credits to the ");
                    oslPrintf_xy(0, 150, "original author.");
                    oslPrintf_xy(0, 170, "PSP pileup is the work of Jack Hosemans, idea was created by");
                    oslPrintf_xy(0, 180, "Callum Osmotherly.");
                    oslPrintf_xy(0, 190, "Thanks to friends and family, and others that helped");
                    if (osl_keys->held.L)
                    {
                        if (osl_keys->held.R)
                        {
                            oslPrintf_xy(0, 200, "Dont think I forgot Ken, HAPPY BIRTHDAY!!!");
                        }
                    }
                    oslPrintf_xy(0, 260, "Press O to go back");
                    if (osl_keys->pressed.circle)
                    {
                        sceKernelDelayThread(10);
                        back = 1;
                        fadein = 255;
                        fadeOut();
                    }

                    if (fadein > 0)
                    {
                        fadein -= 5;
                        fadeIn(fadein, line1, line2);
                        line1 += 2.72;
                        line2 -= 2.72;
                    }
                    else
                    {
                        line1 = 0;
                        line2 = 272;
                    }
                    fullscreenStatic(25);

                    oslEndDrawing();
                    oslSyncFrame();
                }
                break;
            case 3:

                fadeOut();

                fadein = 255;

                oslCls();

                sceKernelDelayThread(10);

                while (!osl_quit && back == 0)
                {
                    if (EndOfStream() == 1)
                    {
                        Stop();
                        Load("menu.mp3");
                        fillOutputBuffer(musicbuffer, 1, 0);
                        Play();
                    }
                    oslStartDrawing();


                    loadBuffer();
                    oslReadKeys();

                    if (osl_keys->pressed.up)
                    {
                        if (difficulty > 0)
                        {
                            difficulty--;
                        }
                        sceKernelDelayThread(10);
                        ay = 0;
                    }

                    if (osl_keys->pressed.down)
                    {
                        if (difficulty < 2)
                        {
                            difficulty++;
                        }
                        sceKernelDelayThread(10);
                        ay = 0;
                    }





                    if (osl_keys->pressed.cross)
                    {
                        switch (difficulty)
                        {
                        case 0:
                            if (bn != 1)
                            {
                                if (high_score[0] > 100)
                                {
                                    bf -= 100;
                                    writeScore();
                                    bn = 1;
                                }
                            }
                            if (bn == 1)
                            {
                                PONG();
                            }
                            break;
                        case 1:
                            if (cb != 1)
                            {
                                if (high_score[0] > 1000)
                                {
                                    bf -= 1000;
                                    writeScore();
                                    cb = 1;
                                }
                            }
                            if (cb == 1)
                            {
                                one000();
                            }
                            break;

                        case 2:
                            sceKernelDelayThread(10);
                            bv = 0;
                            difficulty = 0;
                            fadein = 255;
                            back = 1;
                            fadeOut();


                        default:
                            break;
                        }
                    }
                    oslStartDrawing();

                    oslCls();
                    oslDrawImageXY (ourImage8,0 ,0 );



                    sprintf(filler, "PONG");
                    if (difficulty == 0)
                    {

                        if (bn == 0)
                        {
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(240, 110, "is LOCKED.");
                            oslPrintf_xy(150, 160, "PONG costs 100 points to unlock.");
                        }
                        if (bn == 1)
                        {
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(240, 110, "is UNLOCKED!");
                        }

                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 110, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 110, filler, dimmedColor);
                    }

                    sprintf(filler, "1000");
                    if (difficulty == 1)
                    {
                        if (cb == 0)
                        {
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(240, 125, "is LOCKED.");
                            oslPrintf_xy(150, 160, "1000 costs 1000 points to unlock. LOL.");
                        }
                        if (cb == 1)
                        {
                            oslSetTextColor(highlightColor);
                            oslPrintf_xy(240, 125, "is UNLOCKED!");
                        }
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 125, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 125, filler, dimmedColor);
                    }

                    sprintf(filler, "Back");
                    if (difficulty == 2)
                    {
                        oslSetTextColor(highlightColor);
                        oslPrintf_xy(201, 140, filler, highlightColor);
                    }
                    else
                    {
                        oslSetTextColor(dimmedColor);
                        oslPrintf_xy(201, 140, filler, dimmedColor);
                    }

                    if (fadein > 0)
                    {
                        fadein -= 5;
                        fadeIn(fadein, line1, line2);
                        line1 += 2.72;
                        line2 -= 2.72;
                    }
                    else
                    {
                        line1 = 0;
                        line2 = 272;
                    }
                    fullscreenStatic(25);




                    oslEndDrawing();
                    oslSyncFrame();

                }
                break;
            case 4:
                fadeOut();
                oslQuit();
                break;
            default:
                break;
            }

        }








        oslStartDrawing();
        oslCls();

        oslDrawImageXY ( ourImage8,0, 0);

	oslSetTextColor(highlightColor);

        sprintf(temp,"Your running score is:%d",bf);

        oslPrintf_xy(150,90,temp,highlightColor);

        sprintf(filler, "Play");
        if (selComponent == 0)
        {
            oslSetTextColor(highlightColor);
            oslPrintf_xy(201, 110, filler, highlightColor);
        }
        else
        {
            oslSetTextColor(dimmedColor);
            oslPrintf_xy(201, 110, filler, dimmedColor);
        }

        sprintf(filler, "Difficulty");
        if (selComponent == 1)
        {
            oslSetTextColor(highlightColor);
            oslPrintf_xy(201, 125, filler, highlightColor);
        }
        else
        {
            oslSetTextColor(dimmedColor);
            oslPrintf_xy(201, 125, filler, dimmedColor);
        }

        sprintf(filler, "Help");
        if (selComponent == 2)
        {
            oslSetTextColor(highlightColor);
            oslPrintf_xy(201, 140, filler, highlightColor);
        }
        else
        {
            oslSetTextColor(dimmedColor);
            oslPrintf_xy(201, 140, filler, dimmedColor);
        }
        sprintf(filler, "Minigames");
        if (selComponent == 3)
        {
            oslSetTextColor(highlightColor);
            oslPrintf_xy(201, 155, filler, highlightColor);
        }
        else
        {
            oslSetTextColor(dimmedColor);
            oslPrintf_xy(201, 155, filler, dimmedColor);
        }

        sprintf(filler, "Exit");
        if (selComponent == 4)
        {
            oslSetTextColor(highlightColor);
            oslPrintf_xy(201, 170, filler, highlightColor);
        }
        else
        {
            oslSetTextColor(dimmedColor);
            oslPrintf_xy(201, 170, filler, dimmedColor);
        }

        if (fadein > 0)
        {
            fadein -= 5;
            fadeIn(fadein, line1, line2);
            line1 += 2.72;
            line2 -= 2.72;
        }
        else
        {
            line1 = 0;
            line2 = 272;
        }

        fullscreenStatic(25);


        oslEndDrawing();

        oslSyncFrame();

        oslAudioVSync();


    }



    animExplosion.Unload();
    oslEndGfx();
    oslQuit();


    sceKernelSleepThread();
    return 0;
}








void checkXbutton()
{
    if (bi != 1)
    {
        oslReadKeys();
        if (osl_keys->pressed.cross)
        {
            bi++;
            bf += k*life*-bh;
            blockSet();
        }
    }
    if (osl_keys->pressed.square)
    {
        nextMp3();
    }
}


void writeScore()
{
    pfile = fopen("score.wtf","w+");
    if (pfile==NULL)
    {
        oslPrintf("the score.wtf score sheet can not be found");
    }
    else
    {
        fprintf(pfile,"%d\n",bf);
    }
    fclose(pfile);
}



void readScore()
{

    pfile = fopen("score.wtf","r");
    if (pfile==NULL)
    {
        oslPrintf("the score.wtf score sheet can not be found");
    }
    else
    {

        fgets(temp, 50, pfile);
        sscanf(temp,"%d",&high_score[0]);

    }
    fclose(pfile);
}


void nextMp3()
{
    by++;
    Stop();
    sprintf(music, "bricks/%d.mp3", by);

    Load(music);
    fillOutputBuffer(musicbuffer, 1, 0);
    if (fillFileBuffer() == 1)
    {
        by = 1;
        sprintf(music, "bricks/%d.mp3", by);
        Load(music);
        fillOutputBuffer(musicbuffer, 1, 0);
    }

    Play();
}

void loadBuffer()
{

    fillOutputBuffer(musicbuffer, 1, 0);
}

void PONG()
{

    while (!osl_quit && back == 0)
    {
        oslStartDrawing();

        oslCls();

        oslDrawImageXY ( ourImage8,0, 0);

        oslReadKeys();

        if (osl_keys->held.up)
        {
            bl -= 2;
        }
        if (osl_keys->held.down)
        {
            bl += 2;
        }

        if (bm > bk)
        {
            bm -= bw;
        }

        if (bm < bk)
        {
            bm += bw;
        }

        if (bk > 242)
        {
            bs = -bs;
        }
        if (bk < 0)
        {
            bs = -bs;
        }

        if (bl < 2)
        {
            bl = 1;
        }
        if (bl > 271)
        {
            bl = 271;
        }

        if (bm < 2)
        {
            bm = 1;
        }
        if (bm > 271)
        {
            bm = 271;
        }

        if (bj < 1)
        {
            bu++;
            bj = 225;
            bk = 121;
            br = -2;
            bs = 0;
        }

        if (bj > 479)
        {
            bt++;
            bj = 225;
            bk = 121;
            br = -2;
            bs = 0;
        }


        while (bp > 0)
        {
            oslDrawLine(bp,bl,bp,bl+bo,Player1);
            bp--;
        }
        bp = 5;

        while (bq < 480)
        {
            oslDrawLine(bq,bm,bq,bm+bo,Player2);
            bq++;
        }
        bq = 475;

        bj -= br;
        bk += bs;


        if (bj < bp+br)
        {
            if (bk > bl-29)
            {
                if (bk < bl+bo)
                {
                    br = -br;

                }
            }
        }

        if (bj+30 > bq+br)
        {
            if (bj+30 < bq-br)
            {

                if (bk > bm-29)
                {
                    if (bk < bm+bo)
                    {
                        br = -br;

                    }
                }
            }
        }

        if (bj < bp+br+1)
        {



            if (bk+15 < bl+20)
            {
                bs -= 1;
            }

            if (bk+15 < bl+10)
            {
                bs -= 2;
            }

            if (bk+15 > bl+30)
            {
                bs += 1;
            }

            if (bk+15 > bl+40)
            {
                bs += 2;
            }
        }

        if (bj > bq-br-1)
        {


            if (bk+15 < bm+20)
            {
                bs += 1;
            }

            if (bk+15 < bm+10)
            {
                bs += 2;
            }

            if (bk+15 > bm+30)
            {
                bs -= 1;
            }

            if (bk+15 > bm+40)
            {
                bs -= 2;
            }
        }




        oslDrawImageXY (ball,bj ,bk );

        sprintf(score,"P1:%d",bt);

        oslPrintf_xy(0, 0, score, Player1);

        sprintf(score,"P2:%d",bu);
        oslPrintf_xy(430, 0, score, Player2);

        oslSyncFrame();

        if (osl_keys->pressed.circle)
        {
            bv = 0;
            bf += bt * 10 * bw;
            writeScore();
            back = 1;
        }

        oslEndDrawing();


    }
}

void one000()
{
    bz = 0;
    ca = 0;
    while (!osl_quit && back == 0)
    {
        oslStartDrawing();

        oslCls();

        sprintf(num, "%d", bz);

        oslSetTextColor(highlightColor);
        oslPrintf_xy(0, 10, " Press X to stop the numbers.");
        oslPrintf_xy(0, 20, " If you get 1000 your running score doubles!");
        oslSetTextColor(RED);
        oslPrintf_xy(200, 150, num);

        oslReadKeys();


        if (osl_keys->pressed.cross)
        {
            ca = 1;
            if (bz == 1000)
            {
                bf = bf*2;
            }
            if (bz > 998)
            {
                if (bz < 1000)
                {
                    bf += 100;
                }
            }

            if (bz < 1002)
            {
                if (bz > 1000)
                {
                    bf += 100;
                }
            }
        }
        if (osl_keys->pressed.circle)
        {
            back = 1;
        }

        if (ca != 1)
        {
            bz++;
        }

        sceDisplayWaitVblankStart();
        oslEndDrawing();
        oslSyncFrame();
    }
}


void spaceShooter()
{

    seconds = time (NULL);
    timeMil = 10000;

    oslSetImageRotCenter(Pic1);
    oslSetImageRotCenter(space);

    ourImage2->stretchX = 3 * ourImage2->sizeX;
    ourImage2->stretchY = 3 * ourImage2->sizeY;

    h = 0;


    while (end == 0 && !osl_quit)
    {



        loadBuffer();
        if (EndOfStream() == 1)
        {
            nextMp3();
        }

        oslStartDrawing();





        oslCls();
        oslDrawImageXY(ourImage2, cl, 0);
        cl -= backspeed;
        oslDrawImageXY(ourImage2, cl+1440, 0);
        if (cl + 1440 == 0)
        {
            cl = 0;
        }
        if (sheild > 0)
        {
            oslDrawImageXY (space,shipX, shipY);
        }
        oslReadKeys();

        if (osl_keys->held.left)
        {
            if (speedX > -3)
            {
                speedX -= 0.5;
            }
        }
        else if (speedX < 0)
        {
            speedX += 0.25;
        }

        if (osl_keys->held.right)
        {
            if (speedX < 3)
            {
                speedX += 0.5;
            }
        }
        else if (speedX > 0)
        {
            speedX -= 0.25;
        }

        if (osl_keys->held.up)
        {
            space->angle -= 2;
            if (speedY > -3)
            {
                speedY -= 0.5;
            }
        }
        else if (speedY < 0)
        {
            speedY += 0.25;
            space->angle += 1;
        }

        if (osl_keys->held.down)
        {
            space->angle += 2;
            if (speedY < 3)
            {
                speedY += 0.5;
            }
        }
        else if (speedY > 0)
        {
            speedY -= 0.25;
            space->angle -= 1;
        }

        if (speedX < -3)
        {
            speedX = -3;
        }
        else if (speedY < -3)
        {
            speedY = -3;
        }
        if (space->angle < -12)
        {
            space->angle = -12;
        }
        else if (space->angle > 12)
        {
            space->angle = 12;
        }

        if (space->angle > 0)
        {
            space->angle--;
        }
        else if (space->angle < 0)
        {
            space->angle++;
        }

        while (cm < 11)
        {
            //srand ( time(NULL) );

            Pic1->angle += (int)object[cm].enrot;
            object[cm].enrot += object[cm].enrotemp;
            if (object[cm].enrot > 360)
            {
                object[cm].enrot = object[cm].enrotemp;
            }
            oslDrawImageXY(Pic1, object[cm].xen,object[cm].yen);
            Pic1->angle = 0;
            if (object[cm].enspeed == 0)
            {
                object[cm].enspeed = rand()%(5)+1;
            }
            object[cm].xen -= object[cm].enspeed;
            if (object[cm].xen < 0)
            {
                object[cm].xen = 480;
                object[cm].yen = rand()%(272);
                if (object[cm].yen < 10)
                {
                    srand ( shipY );
                    object[cm].yen = rand()%(272);
                }
                object[cm].enrot = rand()%(2)+1;
                object[cm].enrotemp = object[cm].enrot;
                object[cm].enspeed = rand()%(5)+1;

            }


            if (collision(space, shipX, shipY, Pic1, object[cm].xen, object[cm].yen ) == 1)

            {
                m = 255;


                animExplosion.setX(object[cm].xen);
                animExplosion.setY(object[cm].yen);
                animExplosion.setRotationAngle((int)object[cm].enrot);
                animExplosion.setCurrentFrame(animExplosion.getStartFrame());
                animExplosion.Play();

                    sheild -= 48;

                object[cm].xen = 480;
                object[cm].yen = rand()%(272);
                object[cm].enspeed = rand()%(5)+1;
                object[cm].enrot = rand()%(2)+1;
                object[cm].enrotemp = object[cm].enrot;

            }

            if (laserCollision(bulletX1, bulletY1, bulletX1, bulletY1, Pic1, object[cm].xen, object[cm].yen) == 1){


                animExplosion.setX(object[cm].xen);
                animExplosion.setY(object[cm].yen);
                animExplosion.setRotationAngle((int)object[cm].enrot);
                animExplosion.setCurrentFrame(animExplosion.getStartFrame());
                animExplosion.Play();

                object[cm].xen = 480;
                object[cm].yen = rand()%(272);
                object[cm].enspeed = rand()%(5)+1;
                object[cm].enrot = rand()%(2)+1;
                object[cm].enrotemp = object[cm].enrot;
		

		}

            cm++;





            //oslPrintf("%d", life);
            if (life == 0)
            {
                ourImage2->stretchX = 1 * ourImage2->sizeX;
                ourImage2->stretchY = 1 * ourImage2->sizeY;
                resetVar();
                fadeOut();
                end = 1;

            }


            oslReadKeys();
            if (osl_keys->held.cross)
            {
                bulletX1 = shipX + 25;
                bulletY1 = shipY;
                bullet1enable = true;
                //h++;
            }
            if (bulletX1 >480)
            {
                bullet1enable = false;
            }



        }

        cm = 0;

        animExplosion.Update();
        animExplosion.Draw();
        while (cm < 15)
        {
            oslDrawLine(0,cm,sheild,cm,(RGBA(255,0,0,sheild_color)));
            cm++;
        }
        cm = 0;

        if (m > 0)
        {
            oslDrawThickCircle(shipX, shipY, 30, (RGBA(255,0,0,(int)m)));
            m -= 2;
        }

        if (m > sheild_color)
        {
            sheild_color = (int)m;
        }
        else
        {
            sheild_color = 150;
        }
        if ((sheild < 480) &&
                (m < 0))
        {
            sheild += recover;
        }
        if (sheild <= 0)
        {
            ////////////////////////// death thread ( i love how this one turned out! :D)
            life--;
            animExplosion.setHeight(125);
            animExplosion.setWidth(160);

            animExplosion.setX(shipX-80);
            animExplosion.setY(shipY-63);
            animExplosion.setRotationAngle(0);
            animExplosion.setDelay(7);
            animExplosion.setCurrentFrame(animExplosion.getStartFrame());
            animExplosion.Play();
            while (c < 100 && !(osl_keys->held.cross))
            {
                oslReadKeys();
                oslStartDrawing();
                oslDrawFillRect(0,0,480,272,(RGBA(0,0,0,50)));
		sprintf(temp,"%d lives left!", life);
                oslPrintf_xy(150,136,"%d lives left!", life);
                animExplosion.Update();
                animExplosion.Draw();
                oslEndDrawing();
                oslSyncFrame();
                c++;
            }
            c = 0;

            sheild = 480;
            animExplosion.setDelay(2);
            animExplosion.setHeight(48);
            animExplosion.setWidth(34);
        }


        shipY += (int)speedY;
        shipX += (int)speedX;
        if (shipX > 480 - space->stretchX*0.5)
        {
            speedX = speedX*-2;
        }
        else if (shipX < 0 + space->stretchX*0.5)
        {
            speedX = speedX*-2;
        }
        if (shipY  > 272 - space->stretchY*0.5)
        {
            speedY = speedY*-2;
        }
        else if (shipY  < 0 + space->stretchY*0.5)
        {
            speedY = speedY*-2;
        }



        if (timeMil != 0)
        {
            oslPrintf("time left: %d", timeMil);
            timeMil--;
        }
       /* else
        {
            if (line1 < 0)
            {
                //bossalpha = false;
                line1 += 2.72;
                line2 -= 2.72;

            }
            else if (line1 > 272)
            {
                //bossalpha = true;
                line1 -= 2.72;
                line2 += 2.72;
            }

             if (bossalpha == false)
            {
                fadein -= 5;
            }
            else
            {
                fadein += 5;
            }

            fadeInOutBoss(fadein, line1, line2);
        }*/

	if(timeMil == 0){
	    while (c < 100 && !(osl_keys->held.cross))
            {
                oslReadKeys();
                oslStartDrawing();
                oslDrawFillRect(0,0,480,272,(RGBA(0,0,0,50)));
		if(k != 10){
			sprintf(temp,"You made it to the next level!");
                	oslPrintf_xy(0,136,temp);
		}
		else{
			sprintf(temp,"YOU BEAT THE GAME! OMFG!");
			oslPrintf_xy(0,136,temp);
		}
                oslEndDrawing();
                oslSyncFrame();
                c++;
            }
            c = 0;
        ourImage2->stretchX = 1 * ourImage2->sizeX;
        ourImage2->stretchY = 1 * ourImage2->sizeY;
	resetVar();
	fadeOut();
	end = 1;
	}

        if ((fadein > 0) &&
                (timeMil > 0))
        {
            fadein -= 5;
            fadeIn(fadein, line1, line2);
            line1 += 2.72;
            line2 -= 2.72;
        }
        else
        {
            line1 = 0;
            line2 = 272;
        }

        if (bullet1enable == true)
        {
            oslDrawLine(bulletX1, bulletY1, bulletX1-5, bulletY1, (RGBA(0,255,0,255)));
            bulletX1 += 3;
        }


        oslEndDrawing();

        oslSyncFrame();
        oslCls();



    }
}

void blockSet()
{


    if (az == h)
    {
        if (life > 1)
        {
            life--;
            if (g > 0)
            {
                g--;
                be--;
            }
        }
    }
    if (ba == h)
    {
        if (life > 1)
        {
            life--;
            if (g > 0)
            {
                g--;
                be--;
            }
        }
    }
    if (h == bg)
    {
        if (g > 0)
        {
            g--;
            be--;
        }
        bg += bg*0.5;
    }
    block[h].num = life;
    block[h].stackx = x;
    x -= 24;
    block[h].enable = true;
    block[h].stacky = y;
    blockCheck();






}

void blockDisplay()
{

    while (c < 21)
    {
        if (block[c].num > 0)
        {
            oslDrawImageXY ( ourImage,block[c].stackx, block[c].stacky);
        }
        if (block[c].num > 1)
        {
            oslDrawImageXY ( ourImage,block[c].stackx, block[c].stacky+17);
        }
        if (block[c].num > 2)
        {
            oslDrawImageXY ( ourImage,block[c].stackx, block[c].stacky+34);
        }

        if ((lineCollision(cd+10,ourImage, block[c].stackx) == 1)&&
                (randnum2 > 200))
        {
            drop = 1;
            randnum1 = 0;
        }


        if ((lineCollision(ce+10,ourImage, block[c].stackx) == 1)&&
                (randnum1 > 200))
        {
            drop = 1;
            randnum2 = 0;
        }


        if (drop == 1)
        {
            if (block[c].enable == true)
            {
                block[c].stacky = block[c+1].stacky;
                block[c].num = block[c+1].num;
            }
            else
            {
                block[c].stackx = 480;
                block[c].num = 0;
                x += 24;
                drop = 0;
                h--;
            }
        }

        if (c == 20)
        {
            if (randnum2 > 200)
            {
                randnum2 = 0;
            }
            if (randnum1 > 200)
            {
                randnum1 = 0;
            }
        }

        c++;
    }
    c = 0;
}

void blockCheck()
{
    if (h >= 1)
    {

        c = h - 1;
        if (block[h].stacky != block[c].stacky)
        {
            if (block[c].enable == true)
            {
                if (block[h].stacky < block[c].stacky)
                {

                    j = block[c].stacky - block[h].stacky;

                    block[h].stacky += j;
                    if (j < 0)
                    {
                        j = j*-1;
                    }
                    j = j/17;
                    life -= j;
                    block[h].num = life;
                    j = 0;
                }
                if (block[h].stacky > block[c].stacky)
                {

                    j = block[h].stacky - block[c].stacky;

                    block[h].stacky -= j;
                    if (j < 0)
                    {
                        j = j*-1;
                    }
                    j = j/17;
                    life -= j;
                    block[h].num = life;
                    j = 0;
                }
            }
        }

    }
    h++;
    c = 0;


}

void resetVar()
{
    a = 10;	// how many times the screen should refresh before going to the next step.
    b = 17;	// how wide the pic1 is so y can be incremented, can be changed to one for a smooth movement if desired.
    c = 0;		// how many pic1's that can fit in the screen lengthways.
    f = 0;		// to make sure that x doesnt get pressed more than once a cycle.
    g = 10;	// refresh for a, a gets reset to this once a is 0
    h = 0;
    l = 0;		// used for testing if X is pressed, another safety procedure.
    x = 456;	// x at the beginning, 24 pixels off the bottom
    y = 0;		// y at the beginning.
    life = 3;
    ay = 3;	// delay for menu
    bd = 0;
    end = 0;

    while (c < 21)
    {
        block[c].stackx = 0;
        block[c].stacky = -51;
        block[c].num = 0;
        block[c].enable = false;
        c++;
    }
    c=0;
if(c < 11){
                object[c].xen = 480;
                object[c].yen = rand()%(272);
                object[c].enspeed = rand()%(5)+1;
                object[c].enrot = rand()%(2)+1;
                object[c].enrotemp = object[cm].enrot;
	c++;
}
c=0;
}

void setImageAlpha(int X, int Y, int alpha, OSL_IMAGE *image)
{

//transparency
    oslSetAlpha(OSL_FX_ALPHA,alpha);

    oslDrawImageXY(image,X,Y);

//deactive transparency
    oslSetAlpha(OSL_FX_RGBA,255);

}
void pileUp()
{


    Stop();
    by = 0;

    if (cc == 1)
    {
        cj = 237;
        ck = 32;
        life = 3;
    }
    if (cc == 0)
    {
        cj = 253;
        ck = 17;
        life = 3;
    }

    for (ay=0; ay<10; ay++)
    {
        sceDisplayWaitVblankStart();
    }

    nextMp3();
    bv = 0;

    while (!osl_quit && end == 0)
    {
        if (fadein > 0)
        {
            fadein -= 5;
            fadeIn(fadein, line1, line2);
            line1 += 2.72;
            line2 -= 2.72;
        }
        else
        {
            line1 = 0;
            line2 = 272;
        }

        oslStartDrawing();

        oslCls();

        oslDrawImageXY ( ourImage2,0, 0);

        if (life > 2)
        {
            oslDrawImageXY ( ourImage,x, y+34);	// display the first three blocks, add an if statement before this to make it display less than three.
        }
        if (life > 1)
        {
            oslDrawImageXY ( ourImage,x, y+17);
        }
        if (life > 0)
        {
            oslDrawImageXY ( ourImage,x, y);
        }



        if (y < ck)
        {
            b = 17;
        }
        ;					// make the bouncing effect, or else it will dissapear offscreen.

        if (life == 3)
        {
            if (y > cj - 34)
            {
                b = -17;
            }
        }
        if (life == 2)
        {
            if (y > cj - 18)
            {
                b = -17;
            }
        }

        if (life == 1)
        {
            if (y > cj)
            {
                b = -17;
            }
        }





        checkXbutton();

        loadBuffer();
        if (EndOfStream() == 1)
        {
            nextMp3();
        }

        blockDisplay();



        if (life < 0)
        {
            life = 0;
        }

        while (life == 0)
        {
            oslDrawImageXY ( ourImage3,0, 0);

            if (bd < 21)
            {
                oslSyncFrame();
                bd++;
            }
            resetVar();
            k = 1;
            if (n == 20)
            {
                n = 19;
            }

            writeScore();

            end = 1;
            fadeOut();

        }

        if (block[n].enable == true)
        {
            if (life > 0)
            {
                oslDrawImageXY ( ourImage4,0, 0);
                oslSyncFrame();
                writeScore();
                while (bc < 20)
                {
                    sceDisplayWaitVblankStart();
                    bc++;
                }
                if (cc == 1)
                {
                    oslSetFont(shooterfont);
                    resetVar();
                    fadeOut();
                    fadein = 50;
                    spaceShooter();
                    fadein = 50;
                    oslSetFont(font);
                }
                resetVar();
                if (n == 20)
                {
                    n = 19;
                }


                k++;
                if (g > 1)
                {
                    a--;
                    g--;
                    be--;
                    g = be;
                    if (az > 1)
                    {
                        az--;
                    }
                    if (az < 12)
                    {
                        if (ba > 1)
                        {
                            ba--;
                        }
                    }
                }
            }
        }
        bh = -ba + 20;

        oslReadKeys();
        if (!(osl_keys->pressed.cross))
        {
            if (bi == 1)
            {
                bi--;
            }
        }



        if (cc == 1)
        {
            ch = rand() % 10 + 1;
            ci = rand() % 10 + 1;
            randnum1 += rand() % 5 + 1;
            randnum2 += rand() % 5 + 1;

            oslDrawFillRect(0, 0, 480, 17, BLACK);
            oslDrawFillRect(0, 255, 480, 272, BLACK);

            oslDrawLine(cd, 267, cd + 20, 267, Player2);
            oslDrawLine(cd, 267, cd + 10, 260, Player2);
            oslDrawLine(cd + 10, 260, cd + 20, 267, Player2);

            oslDrawLine(ce, 5, ce + 20, 5, Player2);
            oslDrawLine(ce, 5, ce + 10, 12, Player2);
            oslDrawLine(ce + 10, 12, ce + 20, 5, Player2);

            if (ch > 5)
            {
                cf += 1;
            }
            if (ch < 5)
            {
                cf -= 1;
            }

            if (ci > 5)
            {
                cg += 1;
            }
            if (ci < 5)
            {
                cg -= 1;
            }

            if (randnum1 > 200)
            {
                oslDrawLine(ce+10,12,ce+10,272,(RGBA(0,255,0,255)));
            }

            if (randnum2 > 200)
            {
                oslDrawLine(cd+10,260,cd+10,0,(RGBA(0,255,0,255)));
            }

            if (ce < 0 )
            {
                cf = 5;
            }
            else if (ce+20 > 460)
            {
                cf = -5;
            }

            if (cf > 5)
            {
                cf = 5;
            }
            else if (cf < -5)
            {
                cf = -5;
            }

            if (cd < 0 )
            {
                cg = 5;
            }
            else if (cd+20 > 460)
            {
                cg = -5;
            }

            if (cg > 5)
            {
                cg = 5;
            }
            else if (cg < -5)
            {
                cf = -g;
            }



            ce += cf;
            cd += cg;
        }


        if (k == 1)
        {
            oslDrawImageXY ( ourImage6,0, 212);
        }

        if (k == 2)
        {
            oslDrawImageXY ( num2,0, 212);
        }

        if (k == 3)
        {
            oslDrawImageXY ( num3,0, 212);
        }

        if (k == 4)
        {
            oslDrawImageXY ( num4,0, 212);
        }

        if (k == 5)
        {
            oslDrawImageXY ( num5,0, 212);
        }

        if (k == 6)
        {
            oslDrawImageXY ( num6,0, 212);
        }

        if (k == 7)
        {
            oslDrawImageXY ( num7,0, 212);
        }

        if (k == 8)
        {
            oslDrawImageXY ( num8,0, 212);
        }

        if (k == 9)
        {
            oslDrawImageXY ( num9,0, 212);
        }

        if (k > 9)
        {
            oslDrawImageXY ( inf,0, 212);
        }
        oslDrawImageXY ( ourImage5,0, 242);



        a = g;

        while (a > 0)
        {
            sceDisplayWaitVblankStart();
            a--;
            checkXbutton();
            if (osl_keys->pressed.L)
            {
                end = 1;
            }
            if (fadein > 0)
            {
                oslDrawImageXY ( ourImage2,0, 0);
                fadein -= 5;
                blockDisplay();
                fadeIn(fadein, line1, line2);
                oslSwapBuffers();
                line1 += 2.72;
                line2 -= 2.72;
            }
            else
            {
                line1 = 0;
                line2 = 272;
            }
        }

        y += b;


        oslEndDrawing();


        oslSwapBuffers();							// display the crude squares onscreen, hopefully to the players amusement.



    }
}




